# include/console/core.h File Reference

Console core definitions. More...

`#include <compiler.h>`
`#include <stdarg.h>`

Include dependency graph for core.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures
struct | console
| A console instance. More...
## Functions
int | console_vprintf (struct console *con, const char *format, va_list ap)
| Formatted output conversion.
int int | console_putstr (struct console *con, const char *str)
| Write a string to a console.
int | console_putchar (struct console *con, int c)
| Write a single character to a console.

## Detailed Description

Console core definitions.

- Compiler: IAR EWAVR32 and GNU GCC for AVR32
- Supported devices: All devices
- AppNote:

Author:
  Atmel Corporation: http://www.atmel.com
  Support and FAQ: http://support.atmel.no/

Definition in file core.h.

## Function Documentation

int console_putchar | ( | struct console * | con,
|  | int | c |
| ) |  |  |

Write a single character to a console.

Parameters:

  | con | The console instance.
  | c | The character to write.

Returns:
  c as an unsigned char cast to an int.

Definition at line 217 of file console.c.

References console_drv_commit(), console_drv_putchar(), and console::drv.

Referenced by dbg_priv_putchar().

Here is the call graph for this function:

int int console_putstr | ( | struct console * | con,
|  | const char * | str |
| ) |  |  |

Write a string to a console.

Parameters:

  | con | The console instance.
  | str | NUL-terminated string.

Returns:
  The number of characters written.

Definition at line 202 of file console.c.

References console_drv_commit(), console_drv_putstr(), and console::drv.

Referenced by dbg_priv_putstr().

Here is the call graph for this function:

int console_vprintf | ( | struct console * | con,
|  | const char * | format,
|  | va_list | ap |
| ) |  |  |

Formatted output conversion.

Produce output according to format on the given console. format is interpreted as a regular printf()-style format string with a few limitations (some specifiers are accepted but ignored.)

Parameters:

  | con | The console instance.
  | format | Format specification.
  | ap | Format arguments as a vararg list.

Returns:
  The number of characters printed.

Definition at line 361 of file console.c.

References printf_conversion::arg, console_drv_commit(), console_drv_print_signed(), console_drv_print_unsigned(), console_drv_putchar(), console_drv_putstr(), console_drv_write(), printf_conversion::d, console::drv, isdigit(), printf_conversion::length, printf_conversion::n, printf_conversion::p, printf_conversion::pad_char, printf_conversion::precision, printf_conversion::s, printf_conversion::spec, STATE_CONVSPEC, STATE_FLAG, STATE_LENGTH, STATE_NORMAL, STATE_PERIOD, STATE_PRECISION, STATE_WIDTH, printf_conversion::u, and printf_conversion::width.

Referenced by console_printf(), and dbg_priv_vprintf().

Here is the call graph for this function: